#include "svc_basic.h"

void svc_basic_onSend(thread t, jpacket p)
{
    session s = (session)(t->data);
    thread t_socket = (thread)(s->send_evt_data);
    xmlnode from;

    xmlnode_hide_attrib(p->x, "to");
    if(p->from != NULL)
    {
        xmlnode_put_attrib(p->x, "from", jid_full(p->from));
    }

    debug("SVC_BASIC: got a packet[%s] to send to the user[%d]",xmlnode2str(p->x),t_socket);

    xmlstream_write(t_socket, p->x);
}

/* the connection/stream has passed all the test by the server when it get's here */
void svc_basic_onNode(thread t, xmlnode in, int type)
{
    tstream ts = (tstream)(t->data);
    char *server = (char *)(ts->data_aux5);
    xmlnode query;
    jpacket p;
    session s;

    printf("jserver basic XML NODE: %d type[%d] [%d]'%s'\n",ts->fd,type,in,xmlnode2str(in));
 
    s = svc_basic_lookup(CMD_CHECK, t, NULL);
    
    if(type == XMLSTREAM_ROOT)
    {
        pth_cleanup_push(svc_basic_cleanup,(void *)t);
        xmlstream_write_header(t, xmlstream_header(NS_CLIENT,NULL,xmlnode_get_attrib(in, "to")));
        server = pstrdup(t->p,xmlnode_get_attrib(in, "to"));
        ts->data_aux5 = (void *)server;
        return;
    }

    if(type == XMLSTREAM_CLOSE)
    {
        /* the connection was closed */
        printf("connection closed\n");
        return;
    }

    if(type == XMLSTREAM_ERROR)
    {
        /* the connection was closed */
        printf("XML error, connection closed\n");
        xmlstream_error(t, "Invalid XML Received");
        return;
    }

    p = jpacket_new(xmlnode_dup(in));

    /* attach the host alias this user is using if a session hasn't started yet */
    if(s == NULL)
        p->from = jid_new(p->p, server);
    else
        p->from = jid_new(p->p, s->id);

    /* check the iq's that we handle as a service from the client */
    if(j_strcmp(xmlnode_get_name(p->x), "iq") == 0)
    {
        query = xmlnode_get_tag(p->x, "query");
        if(j_strcmp(xmlnode_get_attrib(query,"xmlns"),"jabber:iq:auth") == 0 && s == NULL)
        {
            svc_basic_auth(t, p, query);
            xmlstream_write(t,p->x);
            return;
        }else if(j_strcmp(xmlnode_get_attrib(query,"xmlns"),"jabber:iq:roster") == 0){
            svc_basic_roster(t, p, query);
            xmlstream_write(t,p->x);
            return;
        }
    }

    if(s != NULL)
    {
        debug("sending packet to session");
        psend(s->mp_from, p);
    }else{
        debug("no session found for this connection, dropping data");
        xmlnode_free(p->x);
    }
}


void svc_basic_cleanup(void *arg)
{
    thread t = (thread)arg;
    tstream ts = (tstream)(t->data);

    debug("SVC_BASIC: cleanup");
    session_end(svc_basic_lookup(CMD_CHECK,t,NULL));
}
