#include "jserver.h"
#include "dlfcn.h"

/* loads the shared object and calls the init function */
void *dso_load(char *so, char *init, void *arg)
{
    void (*init_h)(void *arg);
    void *so_h;
    char *dlerr;
    char *defso;

    debug("dso_init");

    if(so == NULL)
        return NULL;

    so_h = dlopen(so,RTLD_LAZY);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        error("jserver_dso_load",so);
        error("jserver_dso_load_err",dlerr);
        defso = strgrow(NULL,MODLIBDIR,0,0);
        defso = strgrow(defso,"/",1,0);
        defso = strgrow(defso,so,1,0);
        so_h = dlopen(defso,RTLD_LAZY);

        dlerr = dlerror();
        if(dlerr != NULL)
        {
            error("jserver_dso_load",defso);
            error("jserver_dso_load_err",dlerr);
            free(defso);
            return NULL;
        }
        free(defso);
    }

    if(init == NULL)
        return so_h;

    init_h = dlsym(so_h,init);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        error("jserver_dso_init",init);
        error("jserver_dso_init_err",dlerr);
    }
    (init_h)(arg);

    return so_h;
}



