#include "jserver.h"

/* this file is only for the executable version of the jabber server */

int main (int argc, char** argv)
{
    pth_event_t sigevt;
    sigset_t set;
    int sig;

	jlib_init(LOG2_NONE, NULL);

    printf("Starting Jabber Server\n");

    etherx_init("jabber","secret","localhost",NS_SERVER,&etherx_receive); /* start the connection to etherx which will start up our internals */

    sigemptyset(&set);
    sigaddset(&set, SIGUSR1);
    pth_sigmask(SIG_UNBLOCK, &set, NULL);
    sigevt = pth_event(PTH_EVENT_SIGS, &set, &sig);
 
    /* main thread, wait on restart/kill signals and react appropriately */
    debug("Main loop waiting");
    while (1)
    {
        pth_wait(sigevt);
        debug("Got SIGUSR1 in main loop");
    }

    return 0;
}
